:- op(800, yf, [one, zero]).

add(b, b, b).
add(X, b, X) :- binaryZ(X).
add(b, Y, Y) :- binaryZ(Y).
add(X, Y, Z) :- addz(X, Y, Z).

addx(X one,  b, X one)  :- binary(X).
addx(X zero, b, X zero) :- binaryZ(X).
addx(X, Y, Z) :- addz(X, Y, Z).

addy(b, Y one,  Y one)  :- binary(Y).
addy(b, Y zero, Y zero) :- binaryZ(Y).
addy(X, Y, Z) :- addz(X, Y, Z).

addz(X zero, Y zero, Z zero) :- addz(X, Y, Z).
addz(X zero, Y one,  Z one)  :- addx(X, Y, Z).
addz(X one,  Y zero, Z one)  :- addy(X, Y, Z).
addz(X one,  Y one,  Z zero) :- addc(X, Y, Z).

addc(b, b, b one).
addc(X, b, Z) :- succZ(X, Z).
addc(b, Y, Z) :- succZ(Y, Z).
addc(X, Y, Z) :- addC(X, Y, Z).

addX(X zero, b, X one)  :- binaryZ(X).
addX(X one,  b, Z zero) :- succ(X,Z).
addX(X, Y, Z) :- addC(X, Y, Z).

addY(b, Y zero, Y one)  :- binaryZ(Y).
addY(b, Y one,  Z zero) :- succ(Y,Z).
addY(X, Y, Z) :- addC(X, Y, Z).

addC(X zero, Y zero, Z one)  :- addz(X, Y, Z).
addC(X zero, Y one,  Z zero) :- addX(X, Y, Z).
addC(X one,  Y zero, Z zero) :- addY(X, Y, Z).
addC(X one,  Y one,  Z one)  :- addc(X, Y, Z).

binary(b).
binary(X zero) :- binaryZ(X).
binary(X one)  :- binary(X).

binaryZ(X zero) :- binaryZ(X).
binaryZ(X one)  :- binary(X).

succ(b, b one).
succ(X zero, X one)  :- binaryZ(X).
succ(X one,  Z zero) :- succ(X, Z).

succZ(X zero, X one)  :- binaryZ(X).
succZ(X one,  Z zero) :- succ(X, Z).

times(b one,  X, X      ).
times(R zero, S, RS zero) :- times(R, S, RS).
times(R one,  S, RSS    ) :- times(R, S, RS),  add(S, RS zero, RSS).


/*
b2i(b, 0).
b2i(X zero, Z) :- b2i(X, Y), Z is (Y << 1).
b2i(X one,  Z) :- b2i(X, Y), Z is (Y << 1) + 1.

i2b(0, b).
i2b(X, Z) :- X > 0, Bit is X /\ 1,Y is X >> 1, i2b(Bit, Y, Z).
i2b(0, X, Z zero) :- i2b(X, Z).
i2b(1, X, Z one)  :- i2b(X, Z). 
*/